/* NessusJ
 * Copyright (C) 1998 Alexis de Bernis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This class launch a new attack against a given host. Then it
 * gives the control to NessusdStatus.
 *
 *  Please run class NessusJ instead.
 */

import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import com.sun.java.swing.*;
import java.awt.event.*;



class NessusdLauncher extends JFrame implements WindowListener,ActionListener
{
    JButton listPlugs,cancel,go;
    JLabel host,h2Test;
    JTextField target,maxNum;
    Vector plugins;
    DataInputStream fromNessusd;
    DataOutputStream forNessusd;
    JPanel north,center,south;
    PluginList plugList;
    String victim,pluginsOrder[];
    NessusdConnection parent;
    Preferences prefs;
    Hashtable families;

    NessusdLauncher(Vector plugins,DataInputStream fromNessusd,
                    DataOutputStream forNessusd,
                    String host, NessusdConnection parent,
                    Preferences prefs, Hashtable families)
    {
        super("Lauch an new test");
        addWindowListener(this);

        this.prefs=prefs;
        this.plugins=plugins;
        this.fromNessusd=fromNessusd;
        this.forNessusd=forNessusd;
        this.parent=parent;
        this.families=families;
        north=new JPanel(new BorderLayout());
        center=new JPanel(new GridLayout(2,2));
        south=new JPanel(new FlowLayout(FlowLayout.CENTER,30,10));
        target=new JTextField(20);
        maxNum=new JTextField(20);
        listPlugs=new JButton("Plugin list");
        listPlugs.addActionListener(this);
        cancel=new JButton("Cancel");
        cancel.addActionListener(this);
        go=new JButton("Go!");
        go.addActionListener(this);
        pluginsOrder=new String[plugins.size()];

        north.add("Center",new JLabel("Connected to "+host,new ImageIcon("connected.gif"),JLabel.LEFT));
//        north.add("West",new Icon(this,"connected.gif",10,5));
        north.add("South",new HRule(500,1,0,10));

        center.add(new JLabel("Host to test : ",JLabel.CENTER));
        center.add(target);
        center.add(new JLabel("Max number of hosts to test : ",JLabel.CENTER));
        center.add(maxNum);

        south.add(listPlugs);
        south.add(cancel);
        south.add(go);
        
        getContentPane().add("North",north);
        getContentPane().add("Center",center);
        getContentPane().add("South",south);

        maxNum.setText("Infinity");

        pack();
        setResizable(false);
        setVisible(true);
    }


    private boolean launchAttack(String target)
    {
        String message;
        String prefix="CLIENT";
        String plugsId="";
        String separator=" <|> ";
        String maxhosts;
        String range;

//*        System.out.println("\nLaunching new attack on "+target);

        int count=0;

        for(int i=0;i<plugins.size();i++)
        {

            if(((PlugIn) plugins.elementAt(i)).isActivated())
            {
//*                System.out.println("Adding plugin : "+((PlugIn) plugins.elementAt(i)).getName());
                plugsId=plugsId+((PlugIn) plugins.elementAt(i)).getId()+";";
                pluginsOrder[count]=((PlugIn) plugins.elementAt(i)).getName();
                count++;

            }
        }

        if(plugsId=="")
            plugsId="0;";

        plugsId=plugsId+"\b";

        if(maxNum.getText().equalsIgnoreCase("infinity"))
            maxhosts="-1";
        else
            maxhosts=maxNum.getText();

        if(prefs.get("scan_hosts").equals("no"))
            range="-1";
        else
            range=prefs.get("scan_range");

        message=prefix+separator+
                "NEW_ATTACK"+separator+
                plugsId+separator+
                maxhosts+separator+
                "1"+separator+
                range+separator+
		target+separator+
                prefix+"\n";

//*        System.out.println("Message : "+message);

        try
        {
            forNessusd.writeBytes(message);
        }catch(IOException e)
        {
            JOptionPane.showMessageDialog(this,"IO error during message sending\nPlease report to <alexisb@mygale.org>","Error",JOptionPane.ERROR_MESSAGE);
            return(false);
        }

        return(true);
    }


//    public boolean handleEvent(Event evt)
//    {
//        if(evt.id==evt.WINDOW_DESTROY || (evt.id==evt.ACTION_EVENT &&
//                                          evt.target==cancel))
//        {
//            back();
//            return(true);
//        }
//
//        if(evt.id==evt.ACTION_EVENT && evt.target==listPlugs)
//        {
//            hide();
//            plugList=new PluginList(this,plugins,families);
//        }
//
//        if(evt.id==evt.ACTION_EVENT && evt.target==go)
//        {
//            victim=target.getText();
//*            System.out.println("Victim : "+victim);
//            if(!launchAttack(victim))
//                JOptionPane.showMessageDialog(this,"An error ocurred in NessusdLauncher","Error",JOptionPane.ERROR_MESSAGE);
//
//            new NessusdStatus(this,fromNessusd,forNessusd,victim,pluginsOrder);
//            dispose();
//
//        }
//
//        return(false);
//    }

    public void back()
    {
        dispose();
        try
        {
            fromNessusd.close();
            forNessusd.close();
        }catch(IOException e) { }
        parent.back();
    }


    public void windowClosing(WindowEvent evt)
    {
        back();
    }

    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Cancel"))
            back();

        if(command.equals("Go!"))
        {
            victim=target.getText();
            if(!launchAttack(victim))
                JOptionPane.showMessageDialog(this,"An error ocurred in NessusdLauncher","Error",JOptionPane.ERROR_MESSAGE);

            new NessusdStatus(this,fromNessusd,forNessusd,victim,pluginsOrder);
            dispose();
        }

        if(command.equals("Plugin list"))
        {
            setVisible(false);
            plugList=new PluginList(this,plugins,families);
        }
    }



    public void windowClosed(WindowEvent evt ) { }
    public void windowOpened(WindowEvent evt) { }
    public void windowOpening(WindowEvent evt ) { }
    public void windowIconified(WindowEvent evt ) { }
    public void windowActivated(WindowEvent evt ) { }
    public void windowDeiconified(WindowEvent evt ) { }
    public void windowDeactivated(WindowEvent evt ) { }


}
